local displayminutes = 0
local displayhours = 0
local displayairtemp = 0
local displaytracktemp = 0

local smallletterwidth = 59
local smallletterheight = 100
local smallletterspace = 7
local letterheight = 254
local letterwidth = 150
local letterspace = 4

local display_race_seconds = 0
local display_race_minutes = 0
local display_race_hours = 0
local leader = 0
local carnbr = 0
local colon = ":"

local display_laps = "00"

math.randomseed(os.time())
local amb_temp_dez = math.random(0,9)
local road_temp_dez = math.random(0,9)

function update(dt)
        local session=ac.getSession(ac.getSim().currentSessionIndex)
        ac.debug("session", session)
        ac.debug("isTimedRace", ac.getSim().isTimedRace)
        ac.debug("currentSessionIndex", ac.getSim().currentSessionIndex)

        if ac.getCar(carnbr).racePosition == 1 then
            leader = carnbr
        end

        if ac.getSim().timeToSessionStart > 10000 then --countdown to session start
            display_race_hours = string.format("%01d", math.floor((ac.getSim().timeToSessionStart)/((1000*60*60))%24)%10)
            display_race_minutes = string.format("%02d", math.floor((ac.getSim().timeToSessionStart)/(1000*60))%60)
            display_race_seconds = string.format("%02d", math.floor((ac.getSim().timeToSessionStart)/1000)%60)
            colon = ":"
            letterpos = 0
    
        elseif ac.getSim().timeToSessionStart > 0 and ac.getSim().timeToSessionStart <=10000 then
            display_race_hours = ""
            display_race_minutes = ""
            display_race_seconds = ""
            colon = ""
            ac.debug("active", "x")

        elseif (ac.getSim().raceSessionType == ac.SessionType.Race and session.isTimedRace == false) then
        

            display_laps = string.format("%02d", (ac.getCar(leader).sessionLapCount+1))
            display_race_hours = string.format("%01d", math.floor((ac.getSim().sessionTimeLeft)/((-1000*60*60))%24)%10)
            display_race_minutes = string.format("%02d", math.floor((ac.getSim().sessionTimeLeft)/(-1000*60))%60)
            display_race_seconds = string.format("%02d", math.floor((ac.getSim().sessionTimeLeft)/-1000)%60)
            colon = ":"
            ac.debug("active", "y")
            ac.debug("sessionTimeLeft", ac.getSim().sessionTimeLeft)

        elseif (ac.getSim().raceSessionType == ac.SessionType.Race and session.isTimedRace or ac.getSim().raceSessionType==ac.SessionType.Qualify or ac.getSim().raceSessionType==ac.SessionType.Practice) then
        -- elseif (ac.getSim().raceSessionType == ac.SessionType.Race and session.isTimedRace or ac.getSim().raceSessionType==ac.SessionType.Qualify or ac.getSim().raceSessionType==ac.SessionType.Practice) then
         
            if ac.getSim().sessionTimeLeft>0 then

                display_race_hours = string.format("%01d", math.floor((ac.getSim().sessionTimeLeft)/((1000*60*60))%24)%10)
                display_race_minutes = string.format("%02d", math.floor((ac.getSim().sessionTimeLeft)/(1000*60))%60)
                display_race_seconds = string.format("%02d", math.floor((ac.getSim().sessionTimeLeft)/1000)%60)
                colon = ":"
            else
                display_race_hours = "0"
                display_race_minutes = "00"
                display_race_seconds = "00"
                colon = ":"
            end
            display_laps = string.format("%02d", (ac.getCar(leader).sessionLapCount+1))
            ac.debug("active", "y")

            
        else -- normal practice mode
            display_race_hours = string.format("%01d", math.floor((ac.getSim().sessionTimeLeft)/((-1000*60*60))%24)%10)
            display_race_minutes = string.format("%02d", math.floor((ac.getSim().sessionTimeLeft)/(-1000*60))%60)
            display_race_seconds = string.format("%02d", math.floor((ac.getSim().sessionTimeLeft)/-1000)%60)
            colon = ":"
            ac.debug("active", "a")
            display_laps = string.format("%02d", (ac.getCar(leader).sessionLapCount+1))
        end


        if ac.getSim().ambientTemperature ~= ac.getSim().ambientTemperature then
            amb_temp_dez = math.random(0,9)
        end
        if ac.getSim().roadTemperature ~= ac.getSim().roadTemperature then
            road_temp_dez = math.random(0,9)
        end

        carnbr=carnbr<ac.getSim().carsCount-1 and carnbr+1 or 0

        displayairtemp = string.format(math.floor((ac.getSim().ambientTemperature)))
        displaytracktemp = string.format(math.floor((ac.getSim().roadTemperature)))
        displayhours = string.format("%02d", math.floor(ac.getSim().timeHours)%24)
		displayminutes = string.format("%02d", math.floor(ac.getSim().timeMinutes)%60)

        -- displayyear = string.format(math.floor((ac.getSim().timestamp)/365/60/60/24+1970))

        local fontdisplaywidth = letterwidth*2+letterspace
        local smallfontdisplaywidth = smallletterwidth*2+smallletterspace

        display.text{ pos=vec2(74,0) , letter=vec2(letterwidth, letterheight), text=display_laps, font="../fonts/36_big", spacing = letterspace, color = rgbm(1, 0.5,  0.2, 1) }
        display.text{ pos=vec2(338,0) , letter=vec2(letterwidth, letterheight), text=display_race_hours, font="../fonts/36_big", spacing = letterspace, alignment = 1, width = fontdisplaywidth, color = rgbm(1, 0.5,  0.2, 1) }
        display.text{ pos=vec2(588,40), letter=vec2(letterwidth, letterheight), text=colon, font="../fonts/36_big", spacing = letterspace, color = rgbm(1, 0.5,  0.2, 1) }
        display.text{ pos=vec2(666,0) , letter=vec2(letterwidth, letterheight), text=display_race_minutes, font="../fonts/36_big", spacing = letterspace, color = rgbm(1, 0.5,  0.2, 1) }
	    display.text{ pos=vec2(920,40), letter=vec2(letterwidth, letterheight), text=colon, font="../fonts/36_big", spacing = letterspace, color = rgbm(1, 0.5,  0.2, 1) }
	    display.text{ pos=vec2(996,0) , letter=vec2(letterwidth, letterheight), text=display_race_seconds, font="../fonts/36_big", spacing = letterspace, color = rgbm(1, 0.5,  0.2, 1) }

        display.text{ pos=vec2(1557,11) , letter=vec2(smallletterwidth, smallletterheight), text=displayhours, font="../fonts/36_big", spacing = smallletterspace, color = rgbm(1, .5,  0.2, 1) }
	    display.text{ pos=vec2(1668,26), letter=vec2(smallletterwidth, smallletterheight), text=colon, font="../fonts/36_big", spacing = -10, color = rgbm(1, 0.5,  0.2, 1) }
	    display.text{ pos=vec2(1708,11) , letter=vec2(smallletterwidth, smallletterheight), text=displayminutes, font="../fonts/36_big", spacing = smallletterspace, color = rgbm(1, 0.5,  0.2, 1) }

        display.text{ pos=vec2(1380,144) , letter=vec2(smallletterwidth, smallletterheight), text=displaytracktemp, font="../fonts/36_big", width = smallfontdisplaywidth, alignment=1, spacing = smallletterspace, color = rgbm(1, 0.5,  0.2, 1) }
        display.text{ pos=vec2(1484,144) , letter=vec2(smallletterwidth, smallletterheight), text=".", font="../fonts/36_big", spacing = -12, color = rgbm(1, 0.5,  0.2, 1) }
        display.text{ pos=vec2(1531,144) , letter=vec2(smallletterwidth, smallletterheight), text=road_temp_dez, font="../fonts/36_big", spacing = -12, color = rgbm(1, 0.5,  0.2, 1) }

        display.text{ pos=vec2(1700,144) , letter=vec2(smallletterwidth, smallletterheight), text=displayairtemp, font="../fonts/36_big", width = smallfontdisplaywidth, alignment=1, spacing = smallletterspace, color = rgbm(1, 0.5,  0.2, 1) }
        display.text{ pos=vec2(1804,144) , letter=vec2(smallletterwidth, smallletterheight), text=".", font="../fonts/36_big", spacing = -12, color = rgbm(1, 0.5,  0.2, 1) }
        display.text{ pos=vec2(1850,144) , letter=vec2(smallletterwidth, smallletterheight), text=amb_temp_dez, font="../fonts/36_big", spacing = -12, color = rgbm(1, 0.5,  0.2, 1) }
    end